// @BNAME@@TYPE@.java

package @PACKAGE@;

import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;
import javax.jms.JMSException;

import org.objectweb.jonas.common.Trace;

/**
 *
 */
public class @BNAME@@TYPE@ implements MessageDrivenBean, MessageListener {   
    static private final int trace = Trace.DB_1;
    private transient MessageDrivenContext mdbContext;
    
    // constructor for the container
    public @BNAME@@TYPE@() {
    }

    // ------------------------------------------------------------------
    // MessageDrivenBean implementation
    // ------------------------------------------------------------------

    /** 
     * Set the associated context. The container call this method
     * after the instance creation. 
     * The enterprise Bean instance should store the reference to the context
     * object in an instance variable. 
     * This method is called with no transaction context.
     *
     * @param MessageDrivenContext A MessageDrivenContext interface for the instance.
     * @throws EJBException Thrown by the method to indicate a failure caused by
     * a system-level error.
     */

    public void setMessageDrivenContext(MessageDrivenContext ctx) {
	Trace.outln(trace, "@BNAME@@TYPE@ setMessageDrivenContext");
	mdbContext = ctx;
    } 

    /**
     * A container invokes this method before it ends the life of the message-driven object. 
     * This happens when a container decides to terminate the message-driven object. 
     *
     * This method is called with no transaction context. 
     *
     * @throws EJBException Thrown by the method to indicate a failure caused by
     * a system-level error.
     */
    public void ejbRemove() {
	Trace.outln(trace, "@BNAME@@TYPE@ ejbRemove");
    }

    /**
     * The Message driven  bean must define an ejbCreate methods with no args.
     *
     */
    public void ejbCreate() {
	Trace.outln(trace, "@BNAME@@TYPE@ ejbCreate");
    }

    /**
     *  onMessage method
     */
    public void onMessage(Message message) {
	Trace.outln(trace, "@BNAME@@TYPE@ onMessage");
    }
}
