package org.objectweb.common;

import java.io.PrintWriter;

public class TraceCore {
    
    static public boolean isDebug = false;	// if the trace(common) is logged
    static public boolean isVerbose = false;	// if we print the verbose message
    
    static public PrintWriter logWriter = null;	// our log writer
    
    /**
     * set the debug core
     */
    static public void setDebug(boolean set) {
	isDebug = set;
    }

    /**
     * return true if debug is set
     */
    static public boolean isDebug() {
	return isDebug;
    }

    /**
     * set the verbose flag
     */
    static public void setVerbose(boolean set) {
	isVerbose = set;
    }
    
    /**
     * set the log writer
     */
    static public void setLogWriter(PrintWriter log) {
	logWriter = log;
    }
    
    /**
     * print the verbose message if the logger is not null
     */
    static public void verbose(String msg) {
	if (isVerbose && logWriter != null)
	    logWriter.println(msg);
    }

    /**
     * print the debug core message if the logger is not null
     */
    static public void debug(String msg) {
	if (isDebug && logWriter != null)
	    logWriter.println(msg);
    }

    /**
     * print the error message if the logger is not null
     */
    static public void error(String msg) {
	if (logWriter != null)
	    logWriter.println(msg);
    }

    /**
     * print the throwing message if the logger is not null
     */
    static public void error(String msg, Throwable th) {
	if (logWriter != null) {
	    logWriter.println(msg);
	    th.printStackTrace(logWriter);
	}
    }

}
