/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): ____________________________________.
 * Contributor(s): ______________________________________.
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */


package org.objectweb.jonas.beandeployer;

/**
 * This interface defines all the constants of the project.
 *
 * @author Magali MORAEL
 */
public class Consts {
    public static final String TITLE_FRAME      = "BeanDeployer";
    public static final String OBLIGATORY_STAR  = " *";
    public static final String DEFAULT_STRING   = "default";
    public static final String EMPTY_STRING     = "";
    public static final String SUSPENSION_LABEL = "...";
    public static final String SEPARATOR        = "_";
    public static final String FIRST_TABULATION_SPACE  = "  ";
    public static final String SECOND_TABULATION_SPACE = "      ";

    public static final String TRUE  = "True";
    public static final String FALSE = "False";

    // For dialog boxes
    public static final String OK     = "Ok";
    public static final String CANCEL = "Cancel";

    public static final int GRIDX_FIRST = 0;
    public static final int GRIDY_FIRST = 0;
    public static final int GRIDWIDTH   = 1;
    public static final int GRIDHEIGHT  = 1;
    public static final int WEIGHTX     = 100;
    public static final int WEIGHTY     = 100;

    //TextField
    public static final int MAX_COLUMNS       = 20;
    public static final int WITDH_TEXT_FIELD  = 300;
    public static final int HEIGHT_TEXT_FIELD = 20;
    public static final int WITDH_TEXT_FIELD_FILE_CHOOSER  = 265;
    public static final int HEIGHT_TEXT_FIELD_FILE_CHOOSER = 20;

    //Label
    public static final int GRIDX_LABEL         = 0;
    public static final int GRIDY_LABEL         = 0;
    public static final int TOP_INSETS_LABEL    = 2;
    public static final int LEFT_INSETS_LABEL   = 0;
    public static final int BOTTOM_INSETS_LABEL = 10;
    public static final int RIGHT_INSETS_LABEL  = 10;

    //ScrollPane
    public static final int GRIDX_SCROLLPANE         = 1;
    public static final int GRIDY_SCROLLPANE         = 0;
    public static final int TOP_INSETS_SCROLLPANE    = 5;
    public static final int LEFT_INSETS_SCROLLPANE   = 10;
    public static final int BOTTOM_INSETS_SCROLLPANE = 10;
    public static final int RIGHT_INSETS_SCROLLPANE  = 0;
    public static final int WIDTH_SCROLLPANE         = 300;
    public static final int HEIGHT_SCROLLPANE        = 125;

    // Separator
    public static final int TOP_INSETS_SEPARATOR    = 10;
    public static final int LEFT_INSETS_SEPARATOR   = 0;
    public static final int BOTTOM_INSETS_SEPARATOR = 10;
    public static final int RIGHT_INSETS_SEPARATOR  = 0;

    // Default
    public static final int TOP_INSETS_DEFAULT    = 0;
    public static final int LEFT_INSETS_DEFAULT   = 0;
    public static final int BOTTOM_INSETS_DEFAULT = 0;
    public static final int RIGHT_INSETS_DEFAULT  = 0;

    //TextArea

    //ComboBox
    public static final int MAXIMUM_ROW_COUNT = 6;
    public static final int WITDH_COMBOBOX    = 300;
    public static final int HEIGHT_COMBOBOX   = 30;

    //Suspension Button
    public static final int WITDH_SUSPENSION_BUTTON  = 25;
    public static final int HEIGHT_SUSPENSION_BUTTON = 20;

    // Panels
    // LABEL communs
    public static final String LABEL_DISPLAY_NAME = "display-name";
    public static final String LABEL_DESCRIPTION  = "description";
    public static final String LABEL_SMALL_ICON   = "small-icon";
    public static final String LABEL_LARGE_ICON   = "large-icon";
    public static final String LABEL_HOME         = "home";
    public static final String LABEL_REMOTE       = "remote";
    public static final String TYPE_HOME          = "Home";
    public static final String TYPE_REMOTE        = "Remote";
    public static final String LABEL_EJB_CLASS    = "ejb-class";
    // Panel EjbJar
    public static final String LABEL_EJB_CLIENT_JAR = "ejb-client-jar";
    // Panel Session   
    public static final String LABEL_SESSION_TYPE     = "session-type";
    public static final String LABEL_STATEFUL         = "Stateful";
    public static final String LABEL_STATELESS        = "Stateless";
    public static final String LABEL_TRANSACTION_TYPE = "transaction-type";
    public static final String LABEL_BEAN             = "Bean";
    public static final String LABEL_CONTAINER        = "Container";
    // Panel Entity
    public static final String LABEL_PERSISTENCE_TYPE = "persistence-type";
    public static final String TYPE_CONTAINER_MANAGED_PERSISTENCE = "Container";
    public static final String TYPE_BEAN_MANAGED_PERSISTENCE      = "Bean";
    public static final String LABEL_PRIM_KEY_CLASS = "prim-key-class";
    public static final String LABEL_PRIM_KEY_FIELD = "primkey-field";
    public static final String LABEL_REENTRANT      = "reentrant";

    // Panel Cmpf
    public static final String LABEL_FIELD_NAME = "field-name";
    // Panel EjbRef
    public static final String LABEL_EJB_REF_NAME = "ejb-ref-name";
    public static final String LABEL_EJB_REF_TYPE = "ejb-ref-type";
    public static final String TYPE_ENTITY        = "Entity";
    public static final String TYPE_SESSION       = "Session";
    public static final String LABEL_EJB_REF_LINK = "ejb-link";
	    
    // Panel Env
    public static final String LABEL_ENV_ENTRY_NAME  = "env-entry-name";
    public static final String LABEL_ENV_ENTRY_TYPE  = "env-entry-type";
    public static final String LABEL_ENV_ENTRY_VALUE = "env-entry-value";
    public static final String TYPE_BOOLEAN = "java.lang.Boolean";
    public static final String TYPE_STRING  = "java.lang.String";
    public static final String TYPE_INTEGER = "java.lang.Integer";
    public static final String TYPE_DOUBLE  = "java.lang.Double";
    public static final String TYPE_BYTE    = "java.lang.Byte";
    public static final String TYPE_SHORT   = "java.lang.Short";
    public static final String TYPE_LONG    = "java.lang.Long";
    public static final String TYPE_FLOAT   = "java.lang.Float";
    // Panel ResRef
    public static final String LABEL_RES_REF_NAME = "res-ref-name";
    public static final String LABEL_RES_TYPE     = "res-type";
    public static final String LABEL_RES_AUTH     = "res-auth";
    public static final String STRING_APPLICATION = "Application";
    public static final String STRING_CONTAINER   = "Container";
    public static final String TYPE_JDBC          = "javax.sql.DataSource";
    public static final String TYPE_JAVAMAIL      = "javax.mail.Session";
    public static final String TYPE_URL           = "java.net.URL";
    public static final String TYPE_QJMS          = "javax.jms.QueueConnectionFactory";
    public static final String TYPE_TJMS          = "javax.jms.TopicConnectionFactory";

    // Panel RoleRef
    public static final String LABEL_ROLE_LINK    = "role-link";
    public static final String LABEL_ROLE_COLUMNS = "Security Roles Name";
    public static final String LABEL_ROLE_NAME    = "role-name";

    // Panel Tx
    public static final String ATTRIBUTE_NOTSUPPORTED = "NotSupported";
    public static final String ATTRIBUTE_SUPPORTS     = "Supports";
    public static final String ATTRIBUTE_REQUIRED     = "Required";
    public static final String ATTRIBUTE_REQUIREDNEW  = "RequiresNew";
    public static final String ATTRIBUTE_MANDATORY    = "Mandatory";
    public static final String ATTRIBUTE_NEVER        = "Never";
    public static final String LABEL_TRANS_ATTRIBUTE  = "trans-attribute";
    // Panel Method
    public static final String LABEL_METHOD_INTF   = "method-intf";
    public static final String LABEL_METHOD_NAME   ="method-name";
    public static final String LABEL_METHOD_PARAMS = "method-params";
    public static final String LABEL_METHOD_PARAM  = "method-param";

    // Panel MethodPermission


    // Panel Role

    // Panel JonasSession
    public static final String LABEL_JNDI_NAME      = "jndi-name";
    public static final String LABEL_JONAS_RESOURCE = "jonas-resource";
    public static final String LABEL_JONAS_EJB_REF  = "jonas-ejb-ref";
    public static final String LABEL_SESSION_TIMEOUT = "session-timeout";

    // Panel JonasEntity
    public static final String LABEL_IS_MODIFIED_METHOD_NAME = "is-modified-method-name";
    public static final String LABEL_PASSIVATION_TIMEOUT = "passivation-timeout";

    // Panel JdbcMapping
    public static final String LABEL_JDBC_TABLE_NAME = "jdbc-table-name"; 
    public static final String LABEL_JDBC_FIELD_NAME = "jdbc-field-name";
    public static final String LABEL_CMP_FIELD_JDBC_MAPPING = "cmp-field-jdbc-mapping";

    // Panel FinderMethodJM
    public static final String LABEL_JONAS_METHOD      = "jonas-method";
    public static final String LABEL_JDBC_WHERE_CLAUSE = "jdbc-where-clause";

    public static final String STRING_EJB_JAR              = "Ejb Jar";
    public static final String STRING_META_INF_JONAS_EJB_JAR_XML = "META-INF/jonas-ejb-jar.xml";
    public static final String STRING_ASSEMBLY_DESCRIPTOR  = "assembly-descriptor";

    public static final String STRING_META_INF_EJB_JAR_XML = "META-INF/ejb-jar.xml";
    public static final String STRING_ENTERPRISE_BEANS     = "enterprise-beans";
    public static final String STRING_SESSION              = "session";
    public static final String STRING_ENTITY               = "entity";
    public static final String STRING_CMPF                 = "CMPF";
    public static final String STRING_EJB_REF              = "EJB-REF";
    public static final String STRING_ENV                  = "ENV";
    public static final String STRING_RES_REF              = "RES-REF";
    public static final String STRING_ROLE_REF             = "ROLE-REF";
    public static final String STRING_TX                   = "TX";
    public static final String STRING_METHOD               = "method";
    public static final String STRING_METHOD_PERMISSION    = "method-permission";
    public static final String STRING_ROLE                 = "ROLE";
    public static final String STRING_JONAS_SESSION        = "jonas-session";
    public static final String STRING_JONAS_ENTITY         = "jonas-entity";
    public static final String STRING_JDBC_MAPPING         = "jdbc-mappping";
    public static final String STRING_FINDER_METHOD_JM     = "finder-method-jdbc-mapping";
    public static final String STRING_FILE                 = "file";
    // Titles of dialog box.
    public static final String NEW_BEAN_TITLE     = "Infornation to create the bean";
    public static final String OBLIGATORY_FIELDS_TO_SAVE_TITLE = "There are obligatory fields to save";


    //New Bean
    public static final String LABEL_EJB_NAME  = "ejb-name";
    public static final String LABEL_BEAN_TYPE = "Bean type";

    //Dialog Class
    public static final String FILE_PATHS    = "FilePaths";
    public static final String LABEL_PACKAGE = "package";
    public static final String LABEL_FILE    = "file";

    // Tree
    public static final String ROOT_NAME = "root";

    // For the frame of BeanDeployer
    public static final int MINIMUM_SIZE_WIDTH  = 100;
    public static final int MINIMUM_SIZE_HEIGHT = 50;
    public static final int DIVIDER_LOCATION    = 100;

    public static final int FRAME_SIZE_WIDTH  = 500;
    public static final int FRAME_SIZE_HEIGHT = 400;

    // location of image's file
    public static final String GIF_NEW   = "images/new.gif";
    public static final String GIF_OPEN  = "images/open.gif";
    public static final String GIF_SAVE  = "images/save.gif";
    public static final String GIF_CUT   = "images/cut.gif";
    public static final String GIF_COPY  = "images/copy.gif";
    public static final String GIF_PASTE = "images/paste.gif";

    // menu items
    public static final String FILE          = "File";
    public static final char   FILE_MNEMONIC = 'f';
    public static final String NEW           = "New Ejb Jar";
    public static final String OPEN          = "Open Ejb Jar";
    public static final String SAVE          = "Save";
    public static final char   SAVE_MNEMONIC = 's';
    public static final String SAVE_AS       = "Save As";
    public static final String CLOSE         = "Close";
    public static final String EXIT          = "Exit";

    public static final String EDIT          = "Edit";
    public static final char   EDIT_MNEMONIC = 'e';
    public static final String CUT           = "Cut";
    public static final String COPY          = "Copy";
    public static final String PASTE         = "Paste";
    public static final String DELETE        = "Delete";

    public static final String BEAN          = "Bean";
    public static final char   BEAN_MNEMONIC = 'b';
    public static final String NEW_BEAN      = "New Bean";

    public static final String INSERT        = "Insert";

    public static final String TOOLS         = "Tools";
    public static final char   TOOLS_MNEMONIC = 't';
    public static final String CHECK         = "Check";
    public static final String INTERPOSITION = "Interposition classes";

    public static final String HELP          = "Help";
    public static final char   HELP_MNEMONIC = 'h';
    public static final String ABOUT         = "About";

    // list of choise for insert menu
    public static final String TITLE_INSERT_FILE                  = "Insert file";
    public static final String TITLE_INSERT_ASSEMBLY_DESCRIPTOR   = "Insert assembly-descriptor";
    public static final String TITLE_INSERT_ENTERPRISE_BEANS      = "Insert enterprise-beans";
    public static final String TITLE_INSERT_SESSION_BEAN          = "Insert session bean";
    public static final String TITLE_INSERT_ENTITY_BEAN           = "Insert entity bean";
    public static final String TITLE_INSERT_CONTAINER_TRANSACTION = "Insert container-transaction";
    public static final String TITLE_INSERT_METHOD_PERMISSION     = "Insert method-permission";
    public static final String TITLE_INSERT_SECURITY              = "Insert security-role";
    public static final String TITLE_INSERT_METHOD                = "Insert method";
    public static final String TITLE_INSERT_CMP_FIELD             = "Insert cmp-field";
    public static final String TITLE_INSERT_EJB_REF               = "Insert ejb-ref";
    public static final String TITLE_INSERT_SECURITY_REF          = "Insert security-role-ref";
    public static final String TITLE_INSERT_ENV_ENTRY             = "Insert env-entry";
    public static final String TITLE_INSERT_RESOURCE_REF          = "Insert resource-ref";
    public static final String TITLE_INSERT_JONAS_ENTITY          = "Insert JOnAS entity";
    public static final String TITLE_INSERT_JDBC_MAPPING          = "Insert jdbc-mapping";
    public static final String TITLE_INSERT_FINDER_METHOD_JM      = "Insert finder-method-jdbc-mapping";
    public static final String TITLE_INSERT_JONAS_SESSION         = "Insert JOnAS session";
    
    public static final String [] INSERT_EJBJAR        = {TITLE_INSERT_FILE};
    public static final String [] INSERT_STANDARDD     = {TITLE_INSERT_ASSEMBLY_DESCRIPTOR,
							  TITLE_INSERT_ENTERPRISE_BEANS};
    public static final String [] INSERT_ENTERPRISE_BEANS    = {TITLE_INSERT_SESSION_BEAN, 
								TITLE_INSERT_ENTITY_BEAN};
    public static final String [] INSERT_ASSENBLY_DESCRIPTOR = { TITLE_INSERT_CONTAINER_TRANSACTION,
                                                                 TITLE_INSERT_METHOD_PERMISSION,
								 TITLE_INSERT_SECURITY};
    public static final String [] INSERT_CONTAINER     = {TITLE_INSERT_METHOD};
    public static final String [] INSERT_METHOD_PERMISSION   = {TITLE_INSERT_METHOD};
    public static final String [] INSERT_ENTITY        = {TITLE_INSERT_CMP_FIELD,
							  TITLE_INSERT_EJB_REF,
							  TITLE_INSERT_ENV_ENTRY, 
							  TITLE_INSERT_RESOURCE_REF,
							  TITLE_INSERT_SECURITY_REF};
    public static final String [] INSERT_SESSION       = {TITLE_INSERT_EJB_REF,
							  TITLE_INSERT_ENV_ENTRY, 
							  TITLE_INSERT_RESOURCE_REF,
							  TITLE_INSERT_SECURITY_REF};
    public static final String [] INSERT_JSPECIFIC     = {TITLE_INSERT_JONAS_ENTITY, 
							  TITLE_INSERT_JONAS_SESSION};
    public static final String [] INSERT_JENTITY       = {TITLE_INSERT_JDBC_MAPPING};
    public static final String [] INSERT_JJDBC_MAPPING = {TITLE_INSERT_FINDER_METHOD_JM};

    // Title for Message Dialog Box
    public static final String TITLE_ERROR_MESSAGE_BOX = "Error Message";
    
}
