/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): ____________________________________.
 * Contributor(s): Bruno Michel and Guillaume Riviere
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.jmx.jadmin.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Iterator;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.objectweb.jonas.jmx.JonasObjectName;
import org.objectweb.jonas.jmx.jadmin.JonasManagementRepr;

public abstract class EntityBeanServlet extends EJBServlet {

    protected String entityBeanInfo(String ejbType, 
				    String fileName, 
				    String ejbName) {
	try {
	    Integer[] entityCounters = 
		(Integer [])JonasManagementRepr.getAttribute(JonasObjectName.ejb(ejbType, 
										 fileName, 
										 ejbName), 
							     "EntityCounters");
	    return (attribute("Passivation Timeout:", 
			      "<b>"+JonasManagementRepr.getAttribute(JonasObjectName.ejb(ejbType, 
											 fileName, 
											 ejbName), 
								     "PassivationTimeOut")+"</b>")
		    +attribute("Entity bean shared:",
			       "<b>"+JonasManagementRepr.getAttribute(JonasObjectName.ejb(ejbType, 
											  fileName, 
											  ejbName), 
								      "Shared")+"</b>")
		    +attribute("Initial Pool size:",
			       "<b>"+JonasManagementRepr.getAttribute(JonasObjectName.ejb(ejbType, 
											  fileName, 
											  ejbName), 
								      "MinPoolSize")+"</b>")
		    +attribute("Current Pool size:",
			       "<b>"+JonasManagementRepr.getAttribute(JonasObjectName.ejb(ejbType, 
											  fileName, 
											  ejbName), 
								      "PoolSize")+"</b>")
		    +attribute("Max number of instances:",
			       "<b>"+JonasManagementRepr.getAttribute(JonasObjectName.ejb(ejbType, 
											  fileName, 
											  ejbName), 
								      "MaxCacheSize")+"</b>")
		    +attribute("Current number of instances:",
			       "<b>"+JonasManagementRepr.getAttribute(JonasObjectName.ejb(ejbType, 
											  fileName, 
											  ejbName), 
								      "CacheSize")+"</b>")
		    +attribute("Instances used in tx:",
			       "<b>"+entityCounters[0]+"</b>")
		    +attribute("Instances used outside tx:",
			       "<b>"+entityCounters[1]+"</b>")
		    +attribute("Instances unused but ready:",
			       "<b>"+entityCounters[2]+"</b>")
		    +attribute("Instances passivated:",
			       "<b>"+entityCounters[3]+"</b>"));
	} catch (Exception e) {
	    return error("Error while getting attribute:", e.getMessage(), 2);
	}
    }
}
