/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): ____________________________________.
 * Contributor(s): Michel Bruno and Guillaume Riviere
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */
package org.objectweb.jonas.server;

import org.objectweb.jonas.common.Trace;
import org.objectweb.jonas.dbm.DataBaseService;

/**
 * MBean Class for  Trace Manangement
 * MBean type: Standard
 * MBean model: Delegate (Trace)
 */
public class JmxTrace implements JmxTraceMBean {

    /**
     * Get the current trace level
     * @return the current tracelevel
     */
    public Boolean [] getCurrentTraceLevel(){
	Boolean [] traceLevel  = new Boolean[32];
	if (Trace.isLevelSet(Trace.DB_0)) traceLevel[0] = new Boolean(true); else  traceLevel[0] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_1)) traceLevel[1] = new Boolean(true); else  traceLevel[1] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_2)) traceLevel[2] = new Boolean(true); else  traceLevel[2] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_3)) traceLevel[3] = new Boolean(true); else  traceLevel[3] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_4)) traceLevel[4] = new Boolean(true); else  traceLevel[4] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_5)) traceLevel[5] = new Boolean(true); else  traceLevel[5] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_6)) traceLevel[6] = new Boolean(true); else  traceLevel[6] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_7)) traceLevel[7] = new Boolean(true); else  traceLevel[7] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_8)) traceLevel[8] = new Boolean(true); else  traceLevel[8] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_9)) traceLevel[9] = new Boolean(true); else  traceLevel[9] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_10)) traceLevel[10] = new Boolean(true); else  traceLevel[10] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_11)) traceLevel[11] = new Boolean(true); else  traceLevel[11] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_12)) traceLevel[12] = new Boolean(true); else  traceLevel[12] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_13)) traceLevel[13] = new Boolean(true); else  traceLevel[13] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_14)) traceLevel[14] = new Boolean(true); else  traceLevel[14] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_15)) traceLevel[15] = new Boolean(true); else  traceLevel[15] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_16)) traceLevel[16] = new Boolean(true); else  traceLevel[16] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_17)) traceLevel[17] = new Boolean(true); else  traceLevel[17] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_18)) traceLevel[18] = new Boolean(true); else  traceLevel[18] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_19)) traceLevel[19] = new Boolean(true); else  traceLevel[19] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_20)) traceLevel[20] = new Boolean(true); else  traceLevel[20] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_21)) traceLevel[21] = new Boolean(true); else  traceLevel[21] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_22)) traceLevel[22] = new Boolean(true); else  traceLevel[22] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_23)) traceLevel[23] = new Boolean(true); else  traceLevel[23] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_24)) traceLevel[24] = new Boolean(true); else  traceLevel[24] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_25)) traceLevel[25] = new Boolean(true); else  traceLevel[25] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_26)) traceLevel[26] = new Boolean(true); else  traceLevel[26] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_27)) traceLevel[27] = new Boolean(true); else  traceLevel[27] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_28)) traceLevel[28] = new Boolean(true); else  traceLevel[28] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_29)) traceLevel[29] = new Boolean(true); else  traceLevel[29] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_30)) traceLevel[30] = new Boolean(true); else  traceLevel[30] = new Boolean(false);
	if (Trace.isLevelSet(Trace.DB_31)) traceLevel[31] = new Boolean(true); else  traceLevel[31] = new Boolean(false);
	return traceLevel;
    }
    
    /**
     * set the trace level
     * @param the new trace level
     */
    public void setCurrentTraceLevel(Boolean [] traceLevel){
	String level = booleanLevelToString(traceLevel);
	Trace.setFilters(level);
	// compilation pb : ??? 
	//DataBaseServiceImpl.traceJdbc();
    }

    /**
     * Get the current trace header
     * @return the current header (true if header set)
     */
    public Boolean getCurrentTraceHeader(){
	return Trace.getCurrentTraceHeader();
    }

    /**
     * set the trace header
     * @param the new trace header
     */
    public void setCurrentTraceHeader(Boolean traceHeader){
	String level = booleanLevelToString(getCurrentTraceLevel());
	Trace.configure(getCurrentTraceOut(), level, traceHeader.booleanValue());
    }

    /**
     * Get the current trace out
     * @return the current out
     */
    public String getCurrentTraceOut(){
	return Trace.getCurrentTraceOut();
    }

    /**
     * set the trace out
     * @param the new trace out
     */
    public void setCurrentTraceOut(String traceOut){
	String level = booleanLevelToString(getCurrentTraceLevel());
	Trace.configure(traceOut , level, getCurrentTraceHeader().booleanValue());
    }

    /**
     * get the description of each trace level
     */
    public String [] getTraceLevelName() {
	String [] levelName = new String [32];
	levelName[0] = "Trace level unused";
	levelName[1] = "Tests ejb";
	levelName[2] = "Env";
	levelName[3] = "Naming";
	levelName[4] = "Jtm, timers";
	levelName[5] = "Jtm -jta";
	levelName[6] = "Implicit propagation of context";
	levelName[7] = "Threads";
	levelName[8] = "Connection manager";
	levelName[9] = "Jdbc,ldap";
	levelName[10] = "Jdbc_xa";
	levelName[11] = "Trace connection pool";
	levelName[12] = "Container (Context)";
	levelName[13] = "Xa resource";
	levelName[14] = "Container, Server";
	levelName[15] = "Generated classe";
	levelName[16] = "Container";
	levelName[17] = "Container (preinvoke/postinvoke)";
	levelName[18] = "Tests ejb (old tests)";
	levelName[19] = "Tools";
	levelName[20] = "Deployment";
	levelName[21] = "Container (pool entitycontext";
	levelName[22] = "Jms";
	levelName[23] = "Tests ejb (old tests)";
	levelName[24] = "Trace level unused";
	levelName[25] = "Security context";
	levelName[26] = "Jmx";
	levelName[27] = "Trace level unused";
	levelName[28] = "Trace level unused";
	levelName[29] = "Trace level unused";
	levelName[30] = "Ldap buffers in and out";
	levelName[31] = "Warnings";
	return levelName;
    }

    /**
     * Convert Boolean [] trace level to String
     * @param Boolean [] to convert
     * @return String result of cnvert
     */
    private String booleanLevelToString(Boolean [] traceLevel) {
	String level = new String();
	int i = 0;
	// first boolean
	while ((i<traceLevel.length) && (!traceLevel[i].booleanValue())) {
	    i++;
	}
	if (i!= traceLevel.length) {
	    level = String.valueOf(i);
	    i++;
	    while ((i<traceLevel.length) &&(!traceLevel[i].booleanValue())) {
		i++;		
	    }
	}
 
	while ((i<traceLevel.length)) {
	    level += "," + i;
	    i++;
	    while ((i < traceLevel.length) && (!traceLevel[i].booleanValue())) {
		i++;
	    }
	}
	return level;
    }
}
