/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): ____________________________________.
 * Contributor(s): Michel Bruno and Guillaume Riviere
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */
package org.objectweb.jonas_ejb.container;

import org.objectweb.jonas_ejb.deployment.api.BeanDesc;


/**
 * Common method interface for JBeanHome and JMdbFactory 
 */
public interface Ejb {

    /**
     * Get the coontainer of this Ejb
     * @return JContainerImpl the container
     */
    public JContainerImpl getContainer();

    /**
     * Get the Deployement descriptor of this Ejb
     * @return JContainerImpl the Container
     */
    public BeanDesc getDeploymentDescriptor();

    /**
     * Get the Instance pool size for this Ejb
     */
    public int poolSize(); 
}
