/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): ____________________________________.
 * Contributor(s): Michel Bruno and Guillaume Riviere
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas_ejb.container;

import java.util.Set;
import org.objectweb.jonas_ejb.deployment.api.EntityJdbcCmpDesc;

/**
 * MBean Class for Entity Cmp EJB Management 
 * MBean type: Standard
 * MBean model: Delegate (JEntityHome)
 */
public class JmxCmpHome extends JmxEntityHome implements JmxCmpHomeMBean {
    // public empty (for the moment) class for cmp MBean
        
    /**
     * Constructor
     * @param JEntityHome home to manage
     */
    public JmxCmpHome(JEntityHome homeToManage) {
	super(homeToManage);
    }

    /**
     * overhead method,  
     * @return String Set The Name Ejb DataSource
     */
    public Set getAllDataSourceName() {
	Set result = super.getAllDataSourceName();
	result.add(((EntityJdbcCmpDesc)desc).getDatasourceJndiName());
	return result;
    }


    
} 
