/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): ____________________________________.
 * Contributor(s): Michel Bruno and Guillaume Riviere
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas_ejb.container;


/**
 * MBean Class for Session sbl EJB Management 
 * MBean type: Standard
 * MBean model: Delegate (JSessionHome)
 */
public class JmxSblHome extends JmxSessionHome implements JmxSblHomeMBean {
    // public empty (for the moment) class for sbl MBean
        
    /**
     * Constructor
     * @param JSessionHome home to manage
     */
    public JmxSblHome(JSessionHome homeToManage) {
	super(homeToManage);
    }

    /**
     * return the size for free ejb object pool
     * @return Integer pool size
     */ 
    public Integer getCurrentEJBObjectFreePoolSize() {
	return new Integer(((JSessionHome)ejbToManage).getCurrentEJBObjectFreePoolSize());
    }

    /**
     * return the size for in use ejb object pool
     * @return Integer pool size
     */ 
    public Integer getCurrentEJBObjectInUsePoolSize(){
	return new Integer(((JSessionHome)ejbToManage).getCurrentEJBObjectInUsePoolSize());
    } 

    
} 
