package org.objectweb.jonas_tm;

import java.io.PrintWriter;

public class TraceTm {
    
    static public boolean isDebugTm = false;	// if the tm is logged
    static public boolean isDebugJta = false;	// if the jta is logged
    static public boolean isVerbose = false;	// if we print the verbose message
    
    static public PrintWriter logWriter = null;	// our log writer
    
    /**
     * set the debug TM
     */
    static public void setDebugTm(boolean set) {
	isDebugTm = set;
    }
    
    /**
     * set the debug JTA
     */
    static public void setDebugJta(boolean set) {
	isDebugJta = set;
    }
    
    /**
     * set the verbose flag
     */
    static public void setVerbose(boolean set) {
	isVerbose = set;
    }
    
    /**
     * set the log writer
     */
    static public void setLogWriter(PrintWriter log) {
	logWriter = log;
    }
    
    /**
     * print the verbose message if the logger is not null
     */
    static public void verbose(String msg) {
	if ((isVerbose) && (logWriter != null))
	    logWriter.println(msg);
    }

    /**
     * print the debug TM message if the logger is not null
     */
    static public void debugTm(String msg) {
	if ((isDebugTm) && (logWriter != null))
	    logWriter.println(msg);
    }

    /**
     * print the debug JTA message if the logger is not null
     */
    static public void debugJta(String msg) {
	if ((isDebugJta) && (logWriter != null))
	    logWriter.println(msg);
    }

    /**
     * print the error message if the logger is not null
     */
    static public void error(String msg) {
	if (logWriter != null)
	    logWriter.println(msg);
    }

    /**
     * print the throwing message if the logger is not null
     */
    static public void error(String msg, Throwable th) {
	if (logWriter != null) {
	    logWriter.println(msg);
	    th.printStackTrace(logWriter);
	}
    }

}
